// Generated by LiveScript 1.4.0
var async, red, delegateEvent, EventEmitter, ExoComm, N, portReservation, path, ServiceRunner, waitUntil, AppRunner;
async = require('async');
red = require('chalk').red;
delegateEvent = require('rails-delegate').delegateEvent;
EventEmitter = require('events').EventEmitter;
ExoComm = require('exocomm-dev');
N = require('nitroglycerin');
portReservation = require('port-reservation');
path = require('path');
ServiceRunner = require('./service-runner');
waitUntil = require('wait').waitUntil;
AppRunner = (function(superclass){
  var prototype = extend$((import$(AppRunner, superclass).displayName = 'AppRunner', AppRunner), superclass).prototype, constructor = AppRunner;
  function AppRunner(appConfig){
    this.appConfig = appConfig;
  }
  prototype.startExocomm = function(done){
    var this$ = this;
    return portReservation.getPort(N(function(exocommPort){
      var x$;
      this$.exocommPort = exocommPort;
      x$ = this$.exocomm = new ExoComm;
      x$.on('listening', function(port){
        return this$.emit('exocomm-online', port);
      });
      x$.listen(this$.exocommPort);
      return delegateEvent('error', 'routing-setup', 'message', {
        from: this$.exocomm,
        to: this$
      });
    }));
  };
  prototype.startServices = function(){
    var this$ = this;
    return waitUntil(function(){
      return this$.exocommPort;
    }, 1, function(){
      var names, i$, len$, name, serviceDir, x$, _, runner;
      names = Object.keys(this$.appConfig.services);
      this$.runners = {};
      for (i$ = 0, len$ = names.length; i$ < len$; ++i$) {
        name = names[i$];
        serviceDir = path.join(process.cwd(), this$.appConfig.services[name].location);
        x$ = this$.runners[name] = new ServiceRunner(name, {
          root: serviceDir,
          EXOCOMM_PORT: this$.exocommPort
        });
        x$.on('online', fn$);
        x$.on('output', fn1$);
      }
      return async.parallel((function(){
        var ref$, results$ = [];
        for (_ in ref$ = this.runners) {
          runner = ref$[_];
          results$.push(runner.start);
        }
        return results$;
      }.call(this$)), function(err){
        return this$.emit('all-services-online');
      });
      function fn$(name){
        return this$.emit('service-online', name);
      }
      function fn1$(data){
        return this$.emit('output', data);
      }
    });
  };
  prototype.portFor = function(serviceName){
    return this.runners[serviceName].config.EXORELAY_PORT;
  };
  prototype.sendServiceConfiguration = function(){
    var config, res$, serviceName, ref$, serviceData, runner;
    res$ = [];
    for (serviceName in ref$ = this.appConfig.services) {
      serviceData = ref$[serviceName];
      runner = this.runners[serviceName];
      res$.push({
        name: serviceName,
        host: 'localhost',
        port: runner.config.EXORELAY_PORT,
        sends: runner.serviceConfig.messages.sends,
        receives: runner.serviceConfig.messages.receives
      });
    }
    config = res$;
    this.exocomm.setServices(config);
    return this.emit('routing-done');
  };
  return AppRunner;
}(EventEmitter));
module.exports = AppRunner;
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}