// Generated by LiveScript 1.4.0
var AppRunner, ref$, bold, cyan, dim, green, red, yaml, Logger, fs, version, appConfig, logger, x$, appRunner;
AppRunner = require('./app-runner');
ref$ = require('chalk'), bold = ref$.bold, cyan = ref$.cyan, dim = ref$.dim, green = ref$.green, red = ref$.red;
yaml = require('js-yaml');
Logger = require('../../logger');
fs = require('fs');
version = require('../../../package.json').version;
console.log(dim("Exosphere SDK " + version + "\n"));
appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
console.log("Running " + green(appConfig.name) + " " + cyan(appConfig.version) + "\n");
logger = new Logger(Object.keys(appConfig.services));
x$ = appRunner = new AppRunner(appConfig);
x$.on('error', function(err){
  return console.log(red(error));
});
x$.on('output', function(data){
  return logger.log(data);
});
x$.on('exocomm-online', function(port){
  return logger.log({
    name: 'exocomm',
    text: "online at port " + port
  });
});
x$.on('service-online', function(name){
  return logger.log({
    name: 'exorun',
    text: "'" + name + "' is running using exorelay port " + appRunner.portFor(name)
  });
});
x$.on('routing-setup', function(){
  var command, ref$, routing, text, receivers, res$, i$, ref1$, len$, receiver, results$ = [];
  logger.log({
    name: 'exocomm',
    text: 'received routing setup'
  });
  for (command in ref$ = appRunner.exocomm.clientRegistry.routes) {
    routing = ref$[command];
    text = "  [ " + bold(command) + " ]  -->  ";
    res$ = [];
    for (i$ = 0, len$ = (ref1$ = routing.receivers).length; i$ < len$; ++i$) {
      receiver = ref1$[i$];
      res$.push(bold(receiver.name) + " (" + receiver.host + ":" + receiver.port + ")");
    }
    receivers = res$;
    text += receivers.join(' & ');
    results$.push(logger.log({
      name: 'exocomm',
      text: text
    }));
  }
  return results$;
});
x$.on('message', function(arg$){
  var sender, message, receivers;
  sender = arg$.sender, message = arg$.message, receivers = arg$.receivers;
  return logger.log({
    name: 'exocomm',
    text: sender + "  --[ " + message + " ]->  " + receivers.join(' and ')
  });
});
x$.startExocomm();
x$.startServices();
x$.on('all-services-online', function(){
  var x$;
  logger.log({
    name: 'exorun',
    text: 'all services online'
  });
  x$ = appRunner;
  x$.on('routing-done', function(){
    return logger.log({
      name: 'exorun',
      text: "application ready"
    });
  });
  x$.sendServiceConfiguration();
  return x$;
});